package info.bukova.isspst.filters;

import static info.bukova.isspst.StringUtils.nullStr;
import info.bukova.isspst.data.Material;

import org.hamcrest.Description;
import org.hamcrest.Factory;
import org.hamcrest.Matcher;
import org.hamcrest.TypeSafeMatcher;

public class MaterialFilter implements Filter<Material> {
	
	private Material condMaterial;
	
	public MaterialFilter(Material condMaterial) {
		this.condMaterial = condMaterial;
	}

	private static class MaterialMatcher extends TypeSafeMatcher<Material> {

		private Material condMaterial;
		
		public MaterialMatcher(Material cond) {
			this.condMaterial = cond;
		}
		
		@Override
		public void describeTo(Description desc) {
			desc.appendText("material matches");
		}

		@Override
		public boolean matchesSafely(Material item) {
			return nullStr(item.getCode()).toLowerCase().contains(nullStr(condMaterial.getCode()).toLowerCase()) 
					&& nullStr(item.getName()).toLowerCase().contains(nullStr(condMaterial.getName()).toLowerCase())
					&& nullStr(item.getDescription()).toLowerCase().contains(nullStr(condMaterial.getDescription()).toLowerCase());
		}
		
		@Factory
		public static Matcher<Material> matchBuilding(Material material) {
			return new MaterialMatcher(material);
		}
	}
	
	@Override
	public MaterialMatcher matcher() {
		return new MaterialMatcher(condMaterial);
	}

	@Override
	public String queryString() {
		// TODO query string
		return "";
	}

}
